;Basis: RasterIRQ-Routine aus dem "Das neue Commodore64 Intern Buch"
;vertikaler Scroller hinzu. Statuszeile springt
;20.3.13: $1f nach $d011 schreiben: Springen gelst, letzte Zeile aber nur obere 4 Pixel sichtbar.
;21.3.13: RasterIRQ auf stabiles Timing gendert, 3. Bereich zum Border ffnen hinzu
;Plattformabstnde = 9 Leerzeilen wie in Amiga-Version
;24.3.13: Versuch mit Musik ber externe Dateien laden
;25.3.13: ein improvisierter Titelscreen, Code in Zonen unterteilt
;29.3.13: Scroll-Hardcopy kopiert nur noch jede 9. Zeile -> deutlich schneller
;30.3.13: Punktezhler hinzu, Pickfruits hinzu, Textausgabe nicht mehr nur Mll
;1.4.13: Plattformreihen werden aus Leveldaten generiert
;4.4.13: Sprite-Animation, erster Test fr ein Koala-Titelbild (Ladeadresse ist frei)
;5.4.13: Titelbild eingebaut, Sprite-Hngenbleib-Kontrolle eingebaut
;6.4.13: Font angepasst, Grenzen fr Playersprite gendert (war teilweise unspielbar)
;7.4.13: Leveldaten komplettiert, Berechnung fr Levelpointer eingebaut
;8.4.13: 24 Picksprites mit einzeln Mehrfarbmglichkeit, Titelscreen mit Wechseltimer

;SIR-CharEdi MD 10/91

!to "downfall.prg",cbm

rz_topline = $2c		;$1f: oben eine Begrenzungslinie zeichnen
rz_oben = $ed			;$ed: Plattformen im roten Streifen, $ef Datenmll, >ef Geflacker
rz_border = $f8			;in $f8 Zeilenmodus wechseln fr Border abschalten
rz_unten = $fe			;$fa ist genau untere Sichtbarkeitskante
; Verschieberegister = $d011 ; 53265 dez, Einschaltwert = 00011011 = $1b = 27
LevelArrayPointer = $2f	;Zeiger auf die Position der aktuellen Zeile in den Leveldaten
TimeCounter = $fb
BlinkCounter = $fc

*=$0801

	;SYS 2064
		!byte $0C,$08,$0A,$00,$9E,$20,$32,$30,$36,$34,$00,$00,$00,$00,$00

!zone TitleScreen		;der Titelscreen
Start
		;jsr ShowTitletext
		jsr ShowKoalapic
		lda #$e0		;Joystick-Eingnge schalten
		sta $dc02
		lda #$00
		sta BlinkCounter
WaitForInput
		lda #$10		;Feuerknopf
		bit $dc00		;Joyport 2
		beq	StartbuttonPressed	;gedrckt? dann Spiel starten
		jsr $ffe4		;Tastaturabfrage
		cmp #$20		;Leertaste
		beq StartbuttonPressed	;gedrckt? dann Spiel starten
		lda BlinkCounter
		cmp #$04
		bne +
		jsr ShowTitleText
		inc BlinkCounter
		jmp WaitForInput
+		cmp #$08
		bcc WaitForInput
		jsr ShowKoalapic
		lda #$00
		sta BlinkCounter
		jmp WaitForInput
StartbuttonPressed
		jsr GameInit
		jsr GameMain
		jsr CheckHighscore
		jmp Start

!zone GameInit		
GameInit	;Initialisieren des Spiels
		lda #$03		;VIC Bank 0
		ora $dd00
		sta $dd00
		lda #$27		;Multicolor aus
		sta $d016
		jsr $e544		;Bildschirm lschen
		lda #$00		;Spielwerte initialisieren
		sta Counter_Platformlines
		sta Counter_Scrollregister
		sta ScorePlayer1
		sta ScorePlayer1+1
		sta ScorePlayer2
		sta ScorePlayer2+1
		lda #$01
		sta Counter_Spacelines
		sta Level_Nr
		sta GameTimingFlag
		lda #$32
		sta FrameTimer
		;Sprites
		lda #$00
		sta $d010		;alle MSB lschen
		lda #1			;Multicolor1 wei
		sta $d025
		lda #0			;Multicolor2 schwarz
		sta $d026
		;Sprite Player1
		lda #8			;Sprite 0 Farbe braun
		sta $d027
		lda #(sprites/64)	;Sprite-Pointer
		sta $07f8
		lda #$64		;X-/Y-Position des Sprites auf 100/29
		sta $d000
		lda #$3d
		sta $d001
		lda #$01
		sta $d015		;Sprite 0 einschalten
		sta $d01c		;Sprite 0 Multicolor einschalten
		;Sprite Player2
		lda NumberOfPlayers	;2-Spieler-Modus?
		beq PrintStatusline	;wenn nicht, Sprite-Init berspringen
		lda #8			;Sprite 1 Farbe braun
		sta $d028
		lda #(sprites/64)+4	;Sprite-Pointer
		sta $07f9
		lda #$dc		;X-/Y-Position des Sprites auf 220/29
		sta $d002
		lda #$3d
		sta $d003
		lda $d015		;Enable-Register
		ora #$02		;+ Sprite2
		sta $d015
		lda $d01c		;Multicolor-Register
		ora #$02		;+ Sprite2
		sta $d01c
PrintStatusline
		;Statuszeile ausgeben
		ldx #$18		;Cursor auf letzte Zeile
		ldy #$00		;erste Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #<StatuslineText
		ldy #>StatuslineText
		jsr $ab1e		;String ausgeben
		lda #$00		;Zeichenfarbe schwarz
		ldy #$27
-		sta $dbc0,y		;unterste Zeile schwrzen
		dey
		bne -
		lda #$32		;Sekundentimer (50 Frames) initialisieren
		sta FrameTimer
		lda #$05		;Zeichen-Farbe Grn
		sta $0286
		jsr CreatePlatformLine	;die erste Plattformreihe in den Zwischenspeicher
		;lda $d018		;Zeichensatz bei $2800 einschalten
		;and #$f0		;Bit 3-1 lschen
		;ora #$0a		;1024*10=$2800
		;sta $d018
		lda #$1a		;Videospeicher bei $0400, Zeichensatz bei $2800
		sta $d018
	
	;Initialisieren des Split-Scrollers
		sei
		lda #$7f		;Timer-IRQ abschalten
		sta $dc0d
		lda $dc0d		;ICR lschen
		lda #rz_oben	;Rasterzeile $f0 als Inter-
		sta $d012		; ruptauslser festlegen
		lda $d011		;Bit 7 in $D011
		and #$7f		; lschen.
		sta $d011
		lda #$01		;Rasterstrahl als Inter-
		sta $d01a		; rupt-quelle definieren
		ldx #<(irq_raster_oben)	;IRQ-Vektor bei $0314/
		ldy #>(irq_raster_oben)	; $0315 auf erste
		stx $0314		; Interrupt-
		sty $0315		; Routine verbiegen
		
		lda #$07		;Zhler fr Verschieberegister
		sta Counter_Scrollregister
		cli
		
		; musik initialisieren
		lda #$00		; subtune 0
		tax
		tay
		jsr $1000		; init adresse 
		rts

!zone RasterIRQs
irq_raster_topline
		;Rasterstart ist nicht stabil, ich lasse das mal als "Hochspannungseffekt"
		nop
		nop
		nop
		nop
		lda #$01		;Farbe auf wei
		sta $d021		;Hintergrundfarbe setzen
		lda #rz_oben	;Zeile $fa als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_oben) ;IRQ-Vektor auf
		ldy #>(irq_raster_oben) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		lda #$06		;Farbe auf blau
		sta $d021		;Hintergrundfarbe setzen
		jmp $ea81		;IRQ abschlieen

irq_raster_oben			;Oberkante des feststehenden Statusbereichs
	;dec $d020
	nop		;ohne das flackert die vorletzte Zeile
		lda #rz_border	;Zeile $f8 als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_border) ;IRQ-Vektor auf
		ldy #>(irq_raster_border) ; zweite Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		lda #$04		;Farbe auf purpur
		;sta $d020		;Rahmenfarbe setzen
		sta $d021		;Hintergrundfarbe setzen
		lda #$1f		;Verschieberegister auf max Verschiebung
		sta $d011		;und speichern
		jmp $ea81		;IRQ abschlieen

irq_raster_border
		lda $d011		;Bildschirm
		and #$f7		; auf 24 Zeilen
		sta $d011		; Umschalten
		lda #rz_unten	;Zeile $fa als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_unten) ;IRQ-Vektor auf
		ldy #>(irq_raster_unten) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		jmp $ea81		;IRQ abschlieen
		;das Zurckschalten auf 25 Zeilen bernimmt der 3. Bereich

irq_raster_unten		;Ende des sichtbaren Bereichs
		lda #rz_topline	;Zeile $e8 als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_topline) ;IRQ-Vektor auf
		ldy #>(irq_raster_topline) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		
		lda #$00		;Farbe auf schwarz
		;sta $d020		;Rahmenfarbe setzen
		lda #$06		;Farbe auf blau
		sta $d021		;Hintergrundfarbe setzen
					;Verschiebung im Scroll-Bereich fr nchsten Bilddurchlauf setzen
		;lda $d011		;Verschieberegister laden
		;and #$f8		;untere 3 Bits lschen
		lda #$18		;Textmodus mit 25 Zeilen
		;lda #$10		;Textmodus mit 24 Zeilen
		ora Counter_Scrollregister	;aktuelle Verschiebung setzen
		sta $d011		;speichern
		lda Counter_Scrollregister
		cmp #$07
		bne dontMoveScreenUp
		jsr MoveScreenUp
dontMoveScreenUp		
		dec Counter_Scrollregister	;Zhler vermindern
		bpl Not7Pixel	
		lda #$07		;Verschiebezhler neu initialisieren
		sta Counter_Scrollregister
Not7Pixel
		jsr $1003		;Musikplayer aufrufen
		lda #$00		;Spielkontrolle freigeben
		sta GameTimingFlag
	;inc $d020
		jmp $ea81		;IRQ abschlieen
		
!zone TimerIRQs
SetTimer				;Akku=1/60s-Zhler, X+Y=Zieladresse
		sei
		sta TimeCounter
		stx TimerJump+1
		sty TimerJump+2
		ldx #<GetTimer
		ldy #>GetTimer
		stx $0314
		sty $0315
		cli
		rts
		
GetTimer
		dec TimeCounter
		bne +
		ldx #$31
		ldy #$ea
		stx $0314
		sty $0315
TimerJump
		jsr $0000		;das sollte sich modifizieren
+		jmp $ea31
		

!zone Screenroutines		
MoveScreenUp			;neue Hardcopy-Routine, bewegt nur jede 9. Zeile
		lda #$0d		;Beginn der Berechnung mit Zeile 13
		clc
		adc Counter_Spacelines	;Leerzeilenzhler dazu
		cmp #$11		;muss die oberste Zeile gelscht werden?
		bne .LineCopy 	;wenn nicht, beim Scrollen weitermachen
		pha				;Akku auf Stapel
		ldy #$27		;40 Spalten
		lda #$20		;Bildschirmcode Leereichen
.LeerzeileOben
		sta $0400,y		;ins Video-RAM schreiben
		dey				;schon 40 Zeichen gelscht?
		bpl .LeerzeileOben	;wenn nicht, fortfahren
		pla				;Akku zurckholen
		
.LineCopy
		tax				;errechnete Zeilennummer in X
		jsr $e9f0		;Zeiger auf Video-RAM fr Zeile X (Ergebnis steht in $d1 $d2)
		lda $ecf1,x		;Low-Byte holen
		sta $ac			;und speichern
		lda $da,x		;High-Byte
		jsr $e9c8		;Bildschirmzeile nach oben schieben
		jsr $e9f0		;erneut Zeiger auf Video-RAM fr Zeile X holen
		ldy #$27		;40 Spalten
		lda #$20		;Leerzeichen
.Leerzeile
		sta ($ac),y		;ins Video-RAM schreiben
		dey				;schon 40 Zeichen gelscht?
		bpl .Leerzeile	;wenn nicht, fortfahren
		
		txa				;Zeilennummer in Akku
		sec
		sbc #$09		;9 Zeilen abziehen
		bcs .LineCopy	;nchste Zeile kopieren, falls Zeilennr >=0
		;ansonsten nchster Screendurchlauf
		dec Counter_Spacelines	;Zhler verringern
		bne EndMoveScreenUp ;Zhler noch >0?
		lda #$09		;ansonsten neu initialisieren
		sta Counter_Spacelines
		;neue Zeile einfgen
		ldx $0286		;Farbe laden
		ldy #$27		;Zeiger setzen
		sty PlatformFlag	;ins Flag irgendwas >0 schreiben
Copy_PlatformLine_To_Bottom
		lda TempLine,y	;Zeichen holen
		sta $0798,y		;und in Zeile 24 schreiben
		txa				;FarbRAM schreiben
		sta $db98,y
		dey				;nchstes Zeichen
		bpl Copy_PlatformLine_To_Bottom ;fertig, dann weiter
		
		;Level-Rechner
		lda Counter_Platformlines	;Reihen laden
		cmp #59			;Schon 60?
		beq IncreaseLevel	;dann Level erhhen
		inc Counter_Platformlines	;ansonsten Reihen erhhen
		jmp EndMoveScreenUp	;und Ende
IncreaseLevel
		inc Level_Nr	;Level erhhen
		lda #$00		;Reihen zurcksetzen
		sta Counter_Platformlines
		ldx #$17		;letzte Stelle der Levelanzeige
		jsr IncDigitX
		lda $0286		;Plattformfarbe switchen
		eor #$06
		sta $0286
EndMoveScreenUp
		rts


!zone GameMain
GameMain				;hier kommt das eigentliche Spiel hin
		
Wait_GameTimingFlag
		lda GameTimingFlag	;Timing: Kontrollen nur 1x pro Frame aktiv
		bne Wait_GameTimingFlag
		inc GameTimingFlag	;Sperrflag wieder setzen
		
		lda #$04		;Joystickabfrage links Port 2
		bit $dc00
		bne .P1NotLeftPressed
		jsr Player1MoveLeft
		
.P1NotLeftPressed
		lda #$08		;Joystickabfrage rechts Port 2
		bit $dc00
		bne .P1NotRightPressed
		jsr Player1MoveRight

.P1NotRightPressed
		jsr Player1MoveDown
		
		lda $d001		;Y-Position Player1
		cmp #$1c		;oberes Ende
		bcc ExitGame	;Pos kleiner? dann Ende
		cmp #$e1		;unteres Ende
		bcs ExitGame	;Pos grer? dann Ende
		dec FrameTimer
		bne CheckPick
		ldx #$09		;letzte Stelle der Punktanzeige
		jsr IncDigitX
		lda #$32
		sta FrameTimer
CheckPick
		lda $d01e		;Sprite-Sprite-Kollisionsregister
		and #%10000001	;Sprite 0 und 7 kollidiert?
		bpl NewPick
		lda #%01111111	;Sprite7 ausschalten
		and $d015
		sta $d015
		ldy Level_Nr	;Level laden, hhere Level geben mehr Punkte
Add100Points
		ldx #$07		;drittletzte Stelle der Punktanzeige
		jsr IncDigitX	;100 Punkte geben
		dey
		bne Add100Points	;wiederhole * LevelNr (geht vielleicht auch schner)
NewPick
		;soll ein Pick erzeugt werden? Wenn noch keins vorhanden, Wahrscheinlichkeit 1:40
		jsr HandlePickfruits
		
		lda PlatformFlag	;muss eine neue Plattformreihe erzeugt werden?
		beq EndMainLoop
		jsr CreatePlatformLine

EndMainLoop
		jmp GameMain	;weiter im Spiel

ExitGame
		sei
		lda #$00		;Rasterstrahl als Inter-
		sta $d01a		; rupt-quelle ausschalten
		ldx #$31		;IRQ-Vektor auf Standard
		ldy #$ea
		stx $0314
		sty $0315
		lda #$81		;Timer-IRQ erlauben
		sta $dc0d
		cli
		lda #$00
		sta $d404		;Musik ausschalten
		sta $d40b
		sta $d412
		sta $d015		;Sprites ausschalten
		lda #$1b		;Verschieberegister auf Einschaltwert
		sta $d011
		ldx #$0c		;Cursor auf Bildmitte
		ldy #$0f		; positionieren
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #<GameOverText
		ldy #>GameOverText
		jsr $ab1e		;String ausgeben
		;evtl einen squeeze-Sound
		;hier eine 2-Sekunden-Pause einfgen
		lda #$ef
		sta GameTimingFlag
WaitRaster
		cmp $d012
		bne WaitRaster
		dec GameTimingFlag
		bne WaitRaster
		lda #$15		;Zeichensatz-Register wieder auf Standard
		sta $d018
		rts
		
!zone PlayerMove
Player1MoveLeft
		lda $07f8
		ora #%00000010	;Bit1 setzen, Linksbewegung immer Sprite 3+4
		dec PlayerAnimationDelay
		bne NoLeftAnimationP1
		eor #%00000001	;Bit0 switchen
		ldx #$06
		stx PlayerAnimationDelay
NoLeftAnimationP1
		sta $07f8
		lda $d010		;MSB X-Pos holen
		and #$01		;Bit 0
		bne P1IsRight	;gesetzt? dann unten weiter
		lda $d000		;Sprite1 X-Pos
		cmp #$18		;grer als 18 Pixel bis zum linken Rand?
		bcc EndP1MoveLeft	;nein, dann nix tun
		dec $d000		;ansonsten Position vermindern
		dec $d000
		rts				;und Ende
P1IsRight
		dec $d000		;X-Pos vermindern
		dec $d000
		bpl EndP1MoveLeft	;fand ein berlauf statt?
		lda $d010		;wenn ja, MSB lschen
		and #$fe
		sta $d010
EndP1MoveLeft		
		rts

Player1MoveRight
		lda $07f8
		and #%11111101	;Bit1 lschen, Rechtsbewegung immer Sprite 1+2
		dec PlayerAnimationDelay
		bne NoRightAnimationP1
		eor #%00000001	;Bit0 switchen
		ldx #$06
		stx PlayerAnimationDelay
NoRightAnimationP1
		sta $07f8
		lda $d010		;MSB X-Pos holen
		and #$01		;Bit 0
		beq P1IsLeft	;gelscht? dann unten weiter
		lda $d000		;Sprite1 X-Pos
		cmp #$47		;kleiner 256+61 Pixel? (wg breiten Plattf. ist 8 Px in den Rand zulssig)
		bcs EndP1MoveRight	;nein, dann nix tun
		inc $d000		;ansonsten Position erhhen
		inc $d000
		rts				;und Ende
P1IsLeft
		inc $d000		;X-Pos erhhen
		inc $d000
		bne EndP1MoveLeft	;fand ein berlauf statt?
		lda $d010		;wenn ja, MSB setzen
		ora #$01
		sta $d010
EndP1MoveRight
		rts

Player1MoveDown
		inc $d001
		lda $d01f		;Sprite-Hintergrund-Kollisionsregister
		and #$01		;Sprite 0 prfen
		beq EndPlayer1MoveDown	;keine Kollision? weiter fallen
		;Check ob wir hngengeblieben sind
		lda $d001		;Y-Position
		sec
		sbc #$1d		;$1d Rasterzeilen Rand abziehen
		lsr				;Ergebnis ganzzahlig durch 8 teilen ergibt Zeichenzeile
		lsr
		lsr
		tax				;errechnete Zeilennummer in X
		jsr $e9f0		;Zeiger auf Video-RAM fr Zeile X (Ergebnis steht in $d1 $d2)
		lda $d000		;X-Position
		pha
		lda $d010		;MSB ins Carry
		lsr				;1x schieben fr Sprite 0
		pla
		ror				;Ergebnis ganzzahlig durch 8 teilen ergibt Zeichenspalte
		lsr
		lsr
		sec
		sbc #$03		;$18 Pixel (=3 Zeichen) Rand abziehen
		tay
		lda ($d1),y		;Zeichen an der berechneten Position laden
		cmp #$20		;Leerzeichen?
		beq EndPlayer1MoveDown	;dann weiter fallen
		dec $d001		;ansonsten wieder 2 Pixel hher
		dec $d001
EndPlayer1MoveDown
		rts

!zone CheckHighscore
CheckHighscore			;hier kommt der Highscore hin
		rts

!zone Screenroutines
IncNextDigit
		lda #$30		;Bildschirmcode 0
		sta $07c0,x		;an Adresse schreiben
		dex				;Zhler auf nchstlinkes Byte
IncDigitX			;numerische Anzeige in der Statuszeile erhhen
		inc $07c0,x		;Byte erhhen
		lda #$3a		
		cmp $07c0,x		;berlauf?
		beq IncNextDigit
		rts
		
PrintHighscore			;Highscore ausgeben
		rts

!zone Subroutinen
;Subroutine GetRandom liefert eine Zufallszahl im Akku
GetRandom
		lda $dc04
		eor $dc05
		eor $dd04
		adc $dd05
		eor $dd06
		eor $dd07
		rts

;Subroutine HandlePickfruits kmmert sich um die Sammelfrchte
HandlePickfruits
		lda $d015		;SpriteEnableRegister
		and #%10000000
		beq NoActivePick
		dec $d00f		;Sprite Pickfruit nach oben
		lda $d00f
		cmp #$18
		bcs EndPickCheck	;wenn noch nicht oben, nix weiter tun
		lda #%01111111	;ansonsten Sprite7 ausschalten
		and $d015
		sta $d015
		jmp EndPickCheck	;weiter im Spiel
NoActivePick
		jsr GetRandom	;Akku mit Zufallszahl fllen
		;sta $07ca
		cmp #$80		;ein Wert aus der Mitte, da der nchste RND-Aufruf in hnlichem Bereich ist
		bne EndPickCheck	;wenn Wert ungleich gibts kein Pick
		lda #%01111111	;MSB Sprite7 ausschalten
		and $d010
		sta $d010
		jsr GetRandom	;X-Position zufllig holen
		clc
		adc #$20		;mehr in die Mitte schieben
		sta $d00e
		bcc PickEnable
		lda #%10000000	;MSB Sprite7 setzen
		ora $d010
		sta $d010
PickEnable
		jsr GetRandom	;Zufallswert fr Pick-Typ
		tax
		and #$07		;maximal 24: erstmal 0-7 extrahieren
		sta ActivePickType
		txa
		lsr				;hohe 4 Bits als 0-15 nehmen
		lsr
		lsr
		lsr
		clc
		adc ActivePickType	;ergibt zusammen 0-23
		sta ActivePickType
		tax
		clc
		adc #(sprites/64)+8	;Sprite-Basis addieren
		sta $07ff		;Pointer setzen
		lda #$e0		;Y-Koordinate
		sta $d00f
		lda PickSpriteColors,x	;Sprite-Farbe
		sta $d02e
		bpl SingleColor	;Farbwert >128 bedeutet Sprite-Multicolor
		lda #%10000000
		ora $d01c
		bmi SetSpriteColorMode7 ;unbedingter Sprung
SingleColor
		lda #%01111111
		and $d01c
SetSpriteColorMode7
		sta $d01c
		;sta $07ca;test
		lda #%10000000	;Sprite7 einschalten
		ora $d015
		sta $d015
EndPickCheck
		rts

;Subroutine CalcLeveldataBase ermittelt die Basisadresse fr die Leveldatenzeile
CalcLeveldataBase	;Adresse im Speicher derzeit $0b5b
		lda Counter_Platformlines
		beq CalcNewLevel	;hatten wir schon 60 Reihen?
		lda #$05		;ansonsten Pointer 5 Bytes weiterschieben
		clc
		adc LevelArrayPointer
		sta LevelArrayPointer
		bcs +
		rts
+		inc LevelArrayPointer+1
		rts
CalcNewLevel
		lda Level_Nr	;aktuellen Level
		sec				;solange 10 abziehen bis wir unter 0 sind
ReduceToTen
		sbc #$0a
		bcs ReduceToTen
		adc #$09		;jetzt haben wir einen Wertebereich 0-9
		sta $28			;den Wert direkt ins Multiplikationsregister
		clc
		adc $28			;und verdreifachen
		adc $28
		sta $28
		jsr GetRandom	;Zufallszahl
		sec
		sbc #$55
		bcc +			;war im 1. Drittel
		inc $28
		sbc #$55
		bcc +			;war im 2. Drittel
		inc $28
+						;$28 sollte jetzt Wertebereich 0-29 haben
		lda #$00		;Hi-Byte in Multiplikationsregister schreiben
		sta $29
		lda #$2c		;300 ins andere Register (300 Bytes pro Level)
		sta $71
		lda #$01
		sta $72
		jsr $b357		;Multiplikation
		stx LevelArrayPointer	;Leveldaten beginnen bei $3000, Lo-Byte kann direkt verwendet werden
		tya				;Hi-Byte muss addiert werden
		clc
		adc #>LevelData
		sta LevelArrayPointer+1
		rts
		
;Subroutine CreatePlatformLine liest 5 Bytes Leveldaten und speichert diese als Char in der TempLine
CreatePlatformLine
		jsr CalcLeveldataBase	;Speicheradresse der Datenzeile muss bekannt sein
		ldx #$27		;40 Zeichen pro Zeile
		ldy #$04		;5 Bytes werden gebraucht (Abbruch bei Unterlauf)
ConvertByteStart
		lda #$04		;4x 2 Bits verschieben (Abbruch bei 0)
		sta Shiftcounter
		lda (LevelArrayPointer),y
ConvertByteLoop
		pha				;Akku sichern, wird durch AND verndert
		and #$03		;letzte 2 Bits isolieren
		jsr BuildTempLine
		pla				;Akku wieder holen
		lsr
		lsr
		dec Shiftcounter
		bne ConvertByteLoop
		dey
		bpl ConvertByteStart
		lda #$00
		sta PlatformFlag	;Flag lschen
		rts

;Subroutine BuildTempLine schreibt in Abhngigkeit vom Akku 2 Zeichen in die TempLine		
BuildTempLine	;A: Schalter 0-3, X: Zeichenzhler, Y: besetzt
		cmp #$01
		beq ._1
		cmp #$02
		beq ._2
		cmp #$03
		beq ._3
._0		lda #$20		;Leerzeichen
		jmp +
._3		lda #$42		;Boden-Zeichen
+		sta TempLine,x
		dex
.all	sta TempLine,x
		dex
		rts
._1		lda #$41		;Bodenzeichen
		sta TempLine,x
		dex
		lda #$40		;linker Rand
		jmp .all
._2		lda #$44		;rechter Rand
		sta TempLine,x
		dex
		lda #$43		;Boden-Zeichen
		jmp .all
		
;Subroutine ShowKoalapic zeigt ein Koalabild an
ShowKoalapic
		lda $dd00	;VIC auf Bank 1 schalten
		and #$fe
		ora #$02
		sta $dd00
		lda #$d8	; multicolor modus einschalten
		sta $d016
		lda #$78	; bitmap bei $2000, videoram bei $1c00 aktivieren
		sta $d018	;wegen Bank1 $6000				 $5c00
		lda #$3b	; auf bitmap modus umschalten
		sta $d011
		lda #$00	;Rahmen- und Hintergrundfarbe auf schwarz
		sta $d020
		sta $d021
		ldx #$00	; farbdaten ins videoram btw colorram kopieren
GraphicCopyLoop
		lda videoram,x
		sta $5c00,x
		lda videoram+$0100,x
		sta $5d00,x
		lda videoram+$0200,x
		sta $5e00,x
		lda videoram+$0300,x
		sta $5f00,x
		lda colorram,x
		sta $d800,x
		lda colorram+$0100,x
		sta $d900,x
		lda colorram+$0200,x
		sta $da00,x
		lda colorram+$0300,x
		sta $db00,x
		inx
		bne GraphicCopyLoop
SwitchGraphicColor		;ColorRAM d814-d827 schwarz/gelb switchen, macht das "Press Fire" im Titelbild sichtbar
		ldx #$13
		lda $d814
		eor #$07
-		sta $d814,x
		dex
		bpl -
		lda #240		;4 Sekunden
		ldx #<SwitchGraphicColor
		ldy #>SwitchGraphicColor
		jsr SetTimer
		inc BlinkCounter
		rts

;Subroutine ShowTitleText (obsolet)
ShowTitleText
		lda #$03		;VIC Bank 0
		ora $dd00
		sta $dd00
		lda #$27		;Multicolor aus
		sta $d016
		lda #$1b		;Grafik aus
		sta $d011
		lda #$1a		;Videospeicher bei $0400, Zeichensatz bei $2800
		sta $d018
		jsr $e544		;Bildschirm lschen
		lda #$00		;Hintergrund und Rand schwarz
		sta $d020
		sta $d021
		;Copy_TextLine_To_Bottom
		ldx #$00		;Cursor in erste Zeile
		ldy #$0d		;... Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #<ScoreTitle
		ldy #>ScoreTitle
		jsr $ab1e		;String ausgeben
		rts
		
		;!source "printlinenumbers.asm"	;Test-Routine Bildschirmzeilenzhler ausgeben

*=$1000
		!bin "Chris_02.sid",,$7c+2 ; sid player einfgen, startadresse und psid header berspringen 

;------------------------------------------------------------
;game variables
;------------------------------------------------------------
*=$1f00
Level_Nr  
		!byte 1			;255 Level sollten doch genug sein, oder?
Counter_Scrollregister
		!byte 0			;Pixelverschiebung bei Softscrolling
Counter_Spacelines
		!byte 0			;Zwischenraum zwischen den Plattformen (9 Char-Lines)
Counter_Platformlines
		!byte 0			;Plattform-Zhler (60 pro Level)
GameTimingFlag
		!byte $01		;Sperrflag fr Spielerkontrolle
PlatformFlag
		!byte $00		;Anforderungsflag fr neue Plattformreihe
FrameTimer
		!byte $32		;alle 50 Frames (=1 Sekunde) gibts 1 Punkt
PlayerAnimationDelay
		!byte 6,6		;Spritewechsel alle x Frames (2. Byte Player2)
NumberOfPlayers
		!byte 0			;Flag fr 1 oder 2 Spieler
ScorePlayer1
		!byte 0,0		;Punktezhler Spieler 1
ScorePlayer2
		!byte 0,0		;Punktezhler Spieler 2
ActivePickType
		!byte 0			;ist das Pick ein Bonus oder normale Frucht?

PickSpriteColors ;Spritefarben, >128 = Multicolor
		!byte 2,204,8,4,5,6,7,8, 9,10,11,12,13,14,15, 200,201,202,203,204,205,206,207,208
TitleText
		!text "PRESS P1 OR P2 FIRE"	; fr Titelscreen
		!byte $22		;String-Ende-Zeichen
StatuslineText
		!text " P1 000000     LEVEL 001      000000 P2"	;Statuszeile
		; 07c0+0123456789abcdef0123456789abcdef01234567
		!byte $22
GameOverText
		!text "GAME OVER"	;fr GameOver
		!byte $22
Shiftcounter !byte 4	;frs Bitshiften
TempLine				;Zwischenspeicher fr die nchste Plattformreihe
		      ;1234567890123456789012345678901234567890
		;!text "   _ffffi   _ffffi    _ffffi   _ffffi   "
		!fill 40,32

*=$2000
sprites
		;Player-Sprites mssen an einer durch 4 teilbaren Zeigeradresse stehen
		!bin "downfall.spr" ; Sprites nach $2000 laden
	
*=$2800
		;!bin "font-9.chr",,2 ; Den Charset nach $2800 laden
		!bin "downfallfont.prg",,2 ; Den Charset nach $2000 laden
		
*=$3000
LevelData
		!bin "leveldaten.bin",,2 ; Leveldaten laden und die Startadresse abschneiden

*=$6000
TitlePicture
	!bin "downfall_title_koala.koa",$1f40,2
videoram
	!bin "downfall_title_koala.koa",$03e8,2+$1f40
colorram
	!bin "downfall_title_koala.koa",$03e8,2+$1f40+$03e8
		
ScoreTitle		
		!text "HALL OF FALL                "
ScoreTable
		!text "SALATOR......... ..........000815"
		!byte $22
